#include <bits/stdc++.h>
using namespace std;
#define int int64_t
void solve() {
    //freopen("input.txt","r","stdin");
    //freopen("output.txt","w","stdout");
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int> > a(n+1);
    for(int i=0;i<m;i++) {
        int v, u;
        cin >> v >> u;
        a[v].push_back(u);
        a[u].push_back(v);
    }
    vector<int> dist(n+1,-1);
    vector<bool> used(n+1,false);
    for(int i=0;i<k;i++) {
        int p, h;
        cin >> p >> h;
        dist[p]=h;
        used[p]=true;
    }
    set<pair<int,int>, greater<pair<int,int> >  > st;
    for(int i=1;i<=n;i++) {
        st.insert({dist[i],i});
    }
    while(st.size()>0) {
        auto it=st.begin();
        pair<int,int> g=(*it);
        st.erase(it);
        //cout << g.first << " " << g.second << endl;
        int v=g.second;
        if(g.first==-1) {
            break;
        }
        used[v]=true;
        for(int i=0;i<a[v].size();i++) {
            int u=a[v][i];
            if(used[u]==true) {
                continue;
            }
            if(dist[u]<g.first-1) {
                st.erase({dist[u],u});
                dist[u]=g.first-1;
                st.insert({dist[u],u});
            }
        }
    }
    vector<int> ans(0);
    for(int i=1;i<=n;i++) {
        if(used[i]==true) {
            ans.push_back(i);
        }
    }
    cout << ans.size() << endl;
    for(int i=0;i<ans.size();i++) {
        cout << ans[i] << " ";
    }
}
int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
