#include <bits/stdc++.h>
using namespace std;
#define int int64_t
const long double eps=1e-16;
const long double INF=1e16;
struct point {
    long double x;
    long double y;
};
long double distt(point a, point b) {
    return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);
}
struct pr {
    long double a;
    long double b;
    long double c;
};
pr post(point a, point b) {
    return {b.y-a.y,a.x-b.x,b.x*a.y-a.x*b.y};
}
pair<long double,int> dist(point a, pr b) {
    long double x=0;
    if((b.a*a.x+b.b*a.y+b.c)>0) {
        x=1;
    }
    if((b.a*a.x+b.b*a.y+b.c)<0) {
        x=-1;
    }
    return {((b.a*a.x+b.b*a.y+b.c)*(b.a*a.x+b.b*a.y+b.c)/(b.a*b.a+b.b*b.b)),x};
}
void solve() {
    cout << fixed << setprecision(18);
    int n;
    cin >> n;
    vector<point> a(n);
    for(int i=0;i<n;i++) {
        cin >> a[i].x >> a[i].y;
    }
    long double ans=INF;
    for(int _=0;_<n;_++) {
        for(int q=0;q<n;q++) {
            if(_==q) {
                continue;
            }
            pr s=post(a[_],a[q]);
            vector<vector<long double> > dp((1<<n),vector<long double>(n,INF));
            for(int i=0;i<n;i++) {
                dp[(1<<i)][i]=0;
            }
            for(int i=1;i<(1<<n);i++) {
                for(int j=0;j<n;j++) {
                    if((i&(1<<j))==0) {
                        continue;
                    }
                    //cout << dp[i][j] << endl;
                    for(int l=0;l<n;l++) {
                        if((i&(1<<l))==(1<<l)) {
                            continue;
                        }
                        pair<int,int> e=dist(a[j],s);
                        pair<int,int> r=dist(a[l],s);
                        long double x=abs(sqrt(e.first)*e.second-sqrt(r.first)*(r.second));
                        if(x>eps) {
                            x-=eps;
                        }
                        long double h=sqrt(distt(a[l],a[j])-x*x);
                        //cout << i << " " << j << " " << l << " " << (i|(1<<l)) << " " << dp[i][j] << " " << x << " " << h << endl;
                        dp[(i|(1<<l))][l]=min(dp[(i|(1<<l))][l],dp[i][j]+x+h);
                    }
                }
            }
            for(int i=0;i<n;i++) {
                ans=min(ans,dp[(1<<n)-1][i]);
            }
        }
    }
    cout << ans << endl;
}
int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
